/*
 * decchi.c
 *
 *	decchi
 *	startsysproc
 *	zaulog, zauview, miru
 *	zaucon
 */
#include <zheaders.h>
#include <stdarg.h>
#include <asm/current.h>

#if 1
extern unsigned char*	GetVramTop(void);
extern unsigned char	EnableAccessVRAM(void);
extern void		DisableAccessVRAM(unsigned char);
#endif

void miru(const char*,...);
void zaulog_write(char *s, unsigned int count);
int zaucomm_putchar(char c);


#define USE_ZAUVIEW	0
#define USE_ZAULOG	0
//#define USE_ZAUVIEW	1
//#define USE_ZAULOG	1
#define ZAULOG_BUFSIZ	(1024*64)
#define ZAULOG_FILE	"F1:ZAULOG.TXT"

//#define ZAUVIEW (&full_screen)
//#define ZAUVIEW (&upper_area)
#define ZAUVIEW (&input_area)

//#define ZAUCONS (&full_screen)
#define ZAUCONS (&upper_area)
//#define ZAUCONS (&input_area)


/*======================================================================*/
/*
 * zx{scrn,wind,font,cdpy}
 */
typedef struct zaurus_screen_t	ZXSCRN;
typedef struct zaurus_window_t	ZXWIND;
typedef struct zaurus_font_t	ZXFONT;
typedef struct zaurus_characterdisplay_t	ZXCDPY;
typedef unsigned char*	p1;
typedef unsigned short*	p2;
typedef unsigned long*	p4;
typedef unsigned int*	pi;
typedef unsigned char	u1;
typedef unsigned short	u2;
typedef unsigned long	u4;
typedef unsigned int	ui;


struct zaurus_screen_t {
	WINDOWHD wh;
	p2	screen_top;
	u2	screen_w;
	u2	screen_h;
	u2	screen_clip_w;
	u2	screen_clip_h;
};


struct zaurus_window_t {
	short	win_x;	/* κɸ x */
	short	win_y;	/* κɸ y */
	u2	win_w;	/*  */
	u2	win_h;	/* ι⤵ */
#if 0
/*	win_w = cell_x + cell_w * cell_m + cell_u - 1 */
/*	win_h = cell_y + cell_h * cell_n + cell_v - 1 */
#endif
};


struct zaurus_font_t {
	p1	fon_data;
	u1	fon_w;
	u1	fon_h;
	u2	fon_bytesize;	/* = ((width + 7 >> 3) << 3) * height */
};
	

struct zaurus_characterdisplay_t {
	ZXSCRN	*scrn;
	ZXWIND	*wind;
	ZXFONT	*font;
	p2	b;		/* bitmap */
	u2	c0, c1;		/* color_0, color_1 */
	u2	cx, cy;		/* cursor-x, cursor-y */
	u2	cell_m;		/* ɽ */
	u2	cell_n;		/* ɽԿ */
	u2	cell_w;		/* ʸ */
	u2	cell_h;		/* ʸι⤵ */
	u2	cell_x0;	/* ȺǺʸȤδֳ, left margin */
	u2	cell_y0;	/* ȺǾʸȤδֳ, top margin */
	u2	cell_x1;	/* ȺǱʸȤδֳ, right margin */
	u2	cell_y1;	/* ȺʸȤδֳ, bottom margin */
	u1	cudown_mode;	/* 0:page_clear, 1:line_clear, 2:rollup */
};

/*======================================================================*/

#define RGB16(r,g,b) (((r)<<8&0xf800)|((g)<<3&0x7e0)|((b)>>3&31))

/*======================================================================*/

static void zxscrn_init_vram(ZXSCRN *scrn)
{
	static int	first = 1;
	p2	b;
	ui	i, j, w, h, k;
	u1	acsVram;
	  /**/
	if(!first){
		return;
	}
	b = scrn->screen_top;
	w = scrn->screen_clip_w;
	h = scrn->screen_clip_h;
	k = 0;
	acsVram = EnableAccessVRAM();
	for(j = 0; j < h; ++j){
		for(i = 0; i < w; ++i){
			*b++ = k;
			k += 1;
		}
		k = k - w + 0x0400;
		b = b - w + scrn->screen_w;
	}
	DisableAccessVRAM(acsVram);
	first = 0;
}


static void zxscrn_init(ZXSCRN *scrn)
{
	WIN_WORK	contentsWindow;
	  /**/
	contentsWindow.userID = APL_WIN; /* APL_SUB_WIN */
	contentsWindow.CrLocPoint.x = 0;
	contentsWindow.CrLocPoint.y = 0;
	contentsWindow.CrSize.x = 1280;
	contentsWindow.CrSize.y = 608;//960;
#if 0
	contentsWindow.WinType = WN_NO_FRAME;
	contentsWindow.PileMode = TOP;
	contentsWindow.DestWinNo = 0;
#else
#if 0
	contentsWindow.WinType = WN_NO_FRAME;
	contentsWindow.DestWinNo = FrontWindow();
	contentsWindow.PileMode = (contentsWindow.DestWinNo)? OVER : TOP ;
#else
	contentsWindow.WinType = WN_TRANSPARENT;   /* Ʃɥ */
	contentsWindow.DestWinNo = FrontWindow();
	contentsWindow.PileMode = (contentsWindow.DestWinNo)? OVER : TOP ;
#endif
#endif
	contentsWindow.OpenPosition = 0;
	contentsWindow.AutoAdjMode = NONE;
	//SetColorV(&contentsWindow.Color,GREEN);
	SetColorV(&contentsWindow.Color,BLACK);
	scrn->wh = OpenWindow(&contentsWindow);
	scrn->screen_top = (p2)GetVramTop();
}

/*======================================================================*/

static void zxwind_setparam(ZXWIND *wind, int x, int y, ui w, ui h)
{
	wind->win_x = x;
	wind->win_y = y;
	wind->win_w = w;
	wind->win_h = h;
}

/*======================================================================*/

static void zxfont_setparam(ZXFONT *font, p1 data, ui w, ui h)
{
	font->fon_data = data;
	font->fon_w = w;
	font->fon_h = h;
	font->fon_bytesize = (((w + 7) >> 3) << 3) * h;
}

/*======================================================================*/

static void zxcdpy_setparam(ZXCDPY *t, ZXSCRN *scrn, ZXWIND *wind, ZXFONT *font, u2 cell_w, u2 cell_h)
{
	t->scrn = scrn;
	t->wind = wind;
	t->font = font;
	t->b = scrn->screen_top + wind->win_x + wind->win_y * scrn->screen_w;
	t->c1 = ~0;
	t->c0 = 0;
	t->cx = 0;
	t->cy = 0;
	t->cell_w = cell_w;
	t->cell_h = cell_h;
	t->cell_m = wind->win_w / cell_w;
	t->cell_n = wind->win_h / cell_h;
	t->cell_x0 = (wind->win_w - t->cell_m * t->cell_w) / 2;
	t->cell_x1 = (wind->win_w - t->cell_m * t->cell_w) - t->cell_x0;
	t->cell_y0 = (wind->win_h - t->cell_n * t->cell_h) / 2;
	t->cell_y1 = (wind->win_h - t->cell_n * t->cell_h) - t->cell_y0;
	t->cudown_mode = 0;
}

/*----------------------------------------------------------------------*/

static void zxcdpy_areaset_(ZXCDPY *t, int cx, int cy, ui col, ui lin, ui cv)
{
	p2	b;
	ui	i, j, w, h;
	  /**/
	b = t->b + cx * t->cell_w + cy * t->cell_h * t->scrn->screen_w;
	w = col * t->cell_w;
	h = lin * t->cell_h;
	for(j = 0; j < h; ++j){
		for(i = 0; i < w; ++i){
			*b++ = cv;
		}
		b += t->scrn->screen_w - w;
	}
}


static void zxcdpy_linescrollup_(ZXCDPY *t, int dst_cy, int cy, ui lin)
{
#if 0
	p2	d, s;
	u2	i, j, w, h;
	  /**/
	d = t->b + dst_cy * t->cell_h * t->scrn->screen_w;
	s = t->b + cy     * t->cell_h * t->scrn->screen_w;
	w = t->cell_m * t->cell_w;
	h = lin       * t->cell_h;
	for(j = 0; j < h; ++j){
		for(i = 0; i < w; ++i){
			*d++ = *s++;
		}
		d = d - i + t->scrn->screen_w;
		s = s - i + t->scrn->screen_w;
	}
#else
	register p2	d, e;
        register int	k, w, h;
	  /**/
	d = t->b + dst_cy * t->cell_h * t->scrn->screen_w;
	k = (cy - dst_cy) * t->cell_h * t->scrn->screen_w;
	w = t->cell_m * t->cell_w;
	h = lin       * t->cell_h;
	do{
                e = d + w;
                do{
                        d[0] = d[k];
                }while(++d < e);
                d  += t->scrn->screen_w - w;
        }while(--h != 0);
#endif
}

/*----------------------------------------------------------------------*/

static void zxcdpy_putc(ZXCDPY *t, ui ch)
{
	p2	b;
	p1	f;
	ui	i, j, w, h, m;
	u1	acsVram;
	  /**/
	b = t->b + t->cx * t->cell_w + t->cy * t->cell_h * t->scrn->screen_w;
	f = t->font->fon_data + ch * t->font->fon_bytesize;
	w = t->font->fon_w;
	h = t->font->fon_h;
	acsVram = EnableAccessVRAM();
	for(j = 0; j < h; ++j){
		for(i = 0; i < w; ++i){
			if((i & 7) == 0){
				m = *f++;
			}
			*b++ = (m & 0x80) ? t->c1 : t->c0;
			m <<= 1;
		}
		b = b - i + t->scrn->screen_w;
	}
	DisableAccessVRAM(acsVram);
}

/*----------------------------------------------------------------------*/

static void zxcdpy_areaset(ZXCDPY *t, int cx, int cy, ui col, ui lin, ui cv)
{
	u1	acsVram;
	  /**/
	acsVram = EnableAccessVRAM();
	zxcdpy_areaset_(t, cx, cy, col, lin, cv);
	DisableAccessVRAM(acsVram);
}


static
void zxcdpy_erase(ZXCDPY *t)
{
	u1	acsVram;
	  /**/
	acsVram = EnableAccessVRAM();
	zxcdpy_areaset_(t,t->cx,t->cy,1,1,t->c0);
	DisableAccessVRAM(acsVram);
}


static
void zxcdpy_cudown(ZXCDPY *t)
{
	u1	acsVram;
#if 1
	//WINDOWHD 	WnHandle;
	POINT 		p0, p1;
	COLOR 		c;
	//CDSPMODE 	Mode;
	USHORT		d;
	unsigned long	u, v;
	int	n;
#endif
	  /**/
	switch(t->cudown_mode){
	case 0:
		if(++t->cy >= t->cell_n){
			t->cy = 0;
			acsVram = EnableAccessVRAM();
			zxcdpy_areaset_(t,0,0,t->cell_m,t->cell_n,t->c0);
			DisableAccessVRAM(acsVram);
		}
		break;
	case 1:
		if(++t->cy >= t->cell_n){
			t->cy = 0;
		}
		acsVram = EnableAccessVRAM();
		zxcdpy_areaset_(t,0,t->cy,t->cell_m,1,t->c0);
		DisableAccessVRAM(acsVram);
		break;
	case 2:
		++t->cy;
		if(t->cy >= t->cell_n){
			n = t->cy - t->cell_n + 1;
#if 0
			if(n >= t->cell_n){
				acsVram = EnableAccessVRAM();
				zxcdpy_areaset_(t,0,0,t->cell_m,t->cell_n,t->c0);
				DisableAccessVRAM(acsVram);
			}else{
				acsVram = EnableAccessVRAM();
				zxcdpy_linescrollup_(t,0,n,t->cell_n-n);
				zxcdpy_areaset_(t,0,t->cell_n-n,t->cell_m,n,t->c0);
				DisableAccessVRAM(acsVram);
			}
			t->cy -= n;
#else
			v = t->c0;
			u = ((v<<8)&0xf80000)|((v<<5)&0xfc00)|((v<<3)&0xf8);
			SetColorV(&c,u);
			u = (unsigned long)1280 * t->cell_w / t->scrn->screen_w;
			v = (unsigned long)960  * t->cell_h / t->scrn->screen_h;
			p0.x = 0;
			p0.y = 0;
			p1.x = 1279;
			p1.y = t->cell_n * v - 1;
			//p1.y = 607;
			if(n >= t->cell_n){
				AreaClear(t->scrn->wh,&p0,&p1,&c,FBSET,NULL);
			}else{
				d = n * v;
				ScrollUp(t->scrn->wh,&p0,&p1,&c,FBSET,true,d);
			}
			t->cy -= n;
#endif
		}
		break;
	}
}


static
void zxcdpy_curight(ZXCDPY *t)
{
	if(++t->cx >= t->cell_m){
		t->cx = 0;
		zxcdpy_cudown(t);
	}
}


static
void zxcdpy_culeft(ZXCDPY *t)
{
	if(t->cx > 0){
		--t->cx;
	}
}

/*----------------------------------------------------------------------*/

static
void zxcdpy_putchar(ZXCDPY *t, ui ch)
{
	switch(ch){
	case 8: /* bs */
		zxcdpy_erase(t);
		zxcdpy_culeft(t);
		zxcdpy_erase(t);
		break;
	case 9: /* tab */
		do{
			zxcdpy_erase(t);
			zxcdpy_curight(t);
		}while((t->cx & 7) != 0);
		break;
	case 10: /* lf */
		zxcdpy_cudown(t);
		break;
	case 13: /* cr */
		t->cx = 0;
		break;
	default:
		zxcdpy_putc(t,ch);
		zxcdpy_curight(t);
		break;
	}
}


static
void zxcdpy_putstr(ZXCDPY *t, char *str)
{
	ui	ch;
	  /**/
	while((ch = *(unsigned char*)str++) != 0){
		zxcdpy_putchar(t,ch);
	}
}


static
void zxcdpy_write(ZXCDPY *t, char *buf, unsigned int count)
{
	ui	ch;
	char	*p, *q;
	  /**/
	for(p = buf, q = p + count; p < q; ++p){
		ch = *(unsigned char*)p;
		zxcdpy_putchar(t,ch);
	}
}

/*======================================================================*/
/*
 * zaucons
 */

static ZXCDPY	zaucons;


void zaucons_miru()
{
	miru("zaucons=%x\n",&zaucons);
	miru("  .scrn=%x\n",&zaucons.scrn);
	miru("  .scrn->screen_top=%x\n",zaucons.scrn->screen_top);
	miru("  .scrn->screen_w=%x\n",zaucons.scrn->screen_w);
	miru("  .scrn->screen_h=%x\n",zaucons.scrn->screen_h);

	miru("  .wind=%x\n",&zaucons.wind);
	miru("  .wind->win_x=%x\n",zaucons.wind->win_x);
	miru("  .wind->win_y=%x\n",zaucons.wind->win_y);
	miru("  .wind->win_w=%x\n",zaucons.wind->win_w);
	miru("  .wind->win_h=%x\n",zaucons.wind->win_h);

	miru("  .font=%x\n",&zaucons.font);
	miru("  .font->fon_data=%x\n",zaucons.font->fon_data);
	miru("  .font->fon_w=%x\n",zaucons.font->fon_w);
	miru("  .font->fon_h=%x\n",zaucons.font->fon_h);
	miru("  .font->fon_bytesize=%x\n",zaucons.font->fon_bytesize);

	miru("  .b=%x\n",zaucons.b);
	miru("  .c0=%x\n",zaucons.c0);
	miru("  .c1=%x\n",zaucons.c1);
	miru("  .cx=%x\n",zaucons.cx);
	miru("  .cy=%x\n",zaucons.cy);
	miru("  .cell_m=%x\n",zaucons.cell_m);
	miru("  .cell_n=%x\n",zaucons.cell_n);
	miru("  .cell_w=%x\n",zaucons.cell_w);
	miru("  .cell_h=%x\n",zaucons.cell_h);
	miru("  .cell_x0=%x\n",zaucons.cell_x0);
	miru("  .cell_y0=%x\n",zaucons.cell_y0);
	miru("  .cell_x1=%x\n",zaucons.cell_x1);
	miru("  .cell_y1=%x\n",zaucons.cell_y1);
	miru("  .cudown_mode=%x\n",zaucons.cudown_mode);
}


void zaucons_init(ZXSCRN *scrn, ZXWIND *wind, ZXFONT *font, u2 cell_w, u2 cell_h)
{
	zxcdpy_setparam(&zaucons,scrn,wind,font,cell_w,cell_h);
	//zaucons.c0 = RGB16(0x20,0x20,0x20);
	//zaucons.c1 = RGB16(0xc0,0xc0,0xc0);
	zaucons.cudown_mode = 2;
zaucons_miru();
	zxcdpy_areaset(&zaucons, 0, 0, zaucons.cell_m, zaucons.cell_n, zaucons.c0);
}


/*
 * from zaucon_put_char
 */
void zaucons_putchar(ui ch)
{
#if USE_ZAULOG
	char	b[1];
#endif
//miru("[zc%02x%ch]",ch,ch>=32&&ch<=126?ch:'.');
	zxcdpy_putchar(&zaucons,ch);
#if USE_ZAULOG
	*b = ch;
	zaulog_write(b,1);
#endif
}


/*
 * from start_kernel
 */
void zaucons_putstr(char *buf)
{
	char	*p;
	for(p = buf; *p != 0; ++p);
	zxcdpy_write(&zaucons,buf,p-buf);
#if USE_ZAULOG
	zaulog_write(buf,p-buf);
#endif
}


/*
 * from zaucon_write
 */
void zaucons_write(char *buf, unsigned int count)
{
	//char	*e;
	  /**/
	zxcdpy_write(&zaucons,buf,count);
#if USE_ZAULOG
	zaulog_write(buf,count);
#endif
}

/*======================================================================*/
/*
 * zauview
 */

static ZXCDPY	zauview;

#if USE_ZAUVIEW
static void zauview_init2(ZXCDPY *z)
{
	static ZXSCRN scrn;
	static ZXWIND wind;
	static ZXFONT font;
	extern u1 fontdata_6x11[];
	  /**/
	scrn.screen_top = (p2)GetVramTop();
	scrn.screen_w = 1024;
	scrn.screen_h = 480;
	scrn.screen_clip_w = 640;
	scrn.screen_clip_h = 480;
	wind.win_x = 5;
	wind.win_y = 310;
	wind.win_w = 630;
	wind.win_h = 168;
	font.fon_data = fontdata_6x11;
	font.fon_w = 6;
	font.fon_h = 11;
	font.fon_bytesize = 11;
	z->scrn = &scrn;
	z->wind = &wind;
	z->font = &font;
	z->b = scrn.screen_top + wind.win_x + wind.win_y * scrn.screen_w;
	z->c0 = 0;
	z->c1 = 0xf0f0;
	z->c1 = 0x0ff0;
	z->cx = 0;
	z->cy = 0;
	z->cell_m = 90;
	z->cell_n = 14;
	z->cell_w = 7;
	z->cell_h = 12;
	z->cell_x0 = 0;
	z->cell_y0 = 0;
	z->cell_x1 = 0;
	z->cell_y1 = 0;
	z->cudown_mode = 0;
}
#endif


void zauview_init(ZXSCRN *scrn, ZXWIND *wind, ZXFONT *font, u2 cell_w, u2 cell_h)
{
#if USE_ZAUVIEW
	//zauview_init2(&zauview);
	zxcdpy_setparam(&zauview,scrn,wind,font,cell_w,cell_h);
	//zauview.c1 = RGB16(0xe0,0xe0,0xe0);
	//zauview.c1 = RGB16(0xf0,0x1c,0x80);
	//zauview.c1 = RGB16(0x08,0xfc,0x80);
	zauview.c1 = RGB16(0xe0,0xc0,0x00);
	//zauview.c1 = RGB16(0xff,0xff,0xff);
	zauview.cudown_mode = 1;
	zxcdpy_areaset(&zauview, 0, 0, zauview.cell_m, zauview.cell_n, zauview.c0);
#endif
}


void zauview_cdpy_write(char *buf, unsigned int count)
{
#if USE_ZAUVIEW
	int	c;
	char	*p, *e;
	static int	cr = 0;
	  /**/
	for(p = buf, e = p + count; p < e; ++p){
		c = *(unsigned char*)p;
		if(c == 13){
			cr = 1;
		}else{
			if(c == 10 && cr == 0){
				zxcdpy_putchar(&zauview,13);
			}
			cr = 0;
		}
		zxcdpy_putchar(&zauview,c);
	}
#endif
}


/*
 * from zaumsc_write
 */
void zauview_write(char *buf, unsigned int count)
{
	zauview_cdpy_write(buf,count);
#if USE_ZAULOG
	zaulog_write(buf,count);
#endif
}

/*======================================================================*/
/*
 * decchi
 */

char *decchi_str_r(char *b, char *e, char *p, char *q, char f, int w)
{
	if(w < q - p){
		w = q - p;
	}
	if(w > e - b){
		w = e - b;
	}
	if(w < q - p){
		q = p + w;
	}else{
		while(w > q - p){
			*b++ = f;
			--w;
		}
	}
	while(p < q){
		*b++ = *p++;
	}
	return b;
}


char *decchi_u16(char *b, char *e, unsigned long u, int w)
{
	char	*p, *q, buf[16];
	  /**/
	p = q = buf + sizeof(buf);
	do{
		*--p = "0123456789abcdef"[u & 15];
		u >>= 4;
	}while(u != 0);
	return decchi_str_r(b,e,p,q,'0',w);
}


char *decchi_u10(char *b, char *e, unsigned long u, int w)
{
	unsigned long	t;
	char	*p, *q, buf[16];
	  /**/
	p = q = buf + sizeof(buf);
	do{
		t = u / 10;
		*--p = (u - t * 10) + '0';
		u = t;
	}while(u != 0);
	return decchi_str_r(b,e,p,q,'0',w);
}


char *decchi_s10(char *b, char *e, long l, int w)
{
	unsigned long	u, t;
	int	s;
	char	*p, *q, buf[16];
	  /**/
	s = 0;
	if(l < 0){
		s = '-';
		l = -l;
	}
	u = l;
	p = q = buf + sizeof(buf);
	do{
		t = u / 10;
		*--p = (u - t * 10) + '0';
		u = t;
	}while(u != 0);
	if(s){
		*--p = s;
	}
	return decchi_str_r(b,e,p,q,' ',w);
}

/*======================================================================*/
/*
 * zaulog
 */

#if USE_ZAULOG
static struct zaulog_t {
	volatile int	sem;
	int	lastproc, nl;
	char	*p, *e,	b[ZAULOG_BUFSIZ];
	char	b2[ZAULOG_BUFSIZ+1];
} zaulog;
#endif


void zaulog_init(void)
{
#if USE_ZAULOG
	FILEHDERROR fh;
	zaulog.sem = 0;
	zaulog.lastproc = 0;
	zaulog.nl = 0;
	zaulog.p = zaulog.b;
	zaulog.e = zaulog.b + sizeof(zaulog.b);
	if((fh = FileCreate((UCHAR*)ZAULOG_FILE,USUAL_FILE)) >= 0){
		(void)FileClose((FILEHD)fh);
	}
	miru(__FUNCTION__" fh=%lx\n",(unsigned long)fh);
	miru(__FUNCTION__" USUAL_FILE=%lx\n",(unsigned long)USUAL_FILE);
	miru(__FUNCTION__" RW_OPEN=%lx\n",(unsigned long)RW_OPEN);
#endif
}


void zaulog_term(void)
{
	;
}


void zaulog_flush(void)
{
#if USE_ZAULOG
	unsigned long	ul, count;
	FILEHDERROR	fh;
	  /**/
	do{
		if(zaulog.sem != 0){
			break;
		}
		zaulog.sem = 1;
		if((count = zaulog.p - zaulog.b) == 0){
			zaulog.sem = 0;
			break;
		}
		memcpy(zaulog.b2,zaulog.b,count);
		zaulog.p = zaulog.b;
		zaulog.sem = 0;
		if((fh = FileOpen((UCHAR*)ZAULOG_FILE,RW_OPEN)) >= 0){
			while(count != 0){
				if(FileMovePtr((FILEHD)fh,FC_FROM_FILEEND,0) < 0){
					break;
				}
				ul = count;
				if(FileBlockWrite((FILEHD)fh,(UCHAR*)zaulog.b2,&ul) < 0){
					break;
				}
				count -= ul;
			}
			(void)FileClose((FILEHD)fh);
		}
	}while(0);
#endif
}

/*----------------------------------------------------------------------*/

void zaulog_write(char *s, unsigned int count)
{
#if USE_ZAULOG
	int	name;
	char	*p, *t, *e;
	  /**/
	t = s + count;
	name = self_getname();
	/**/
	while(zaulog.sem != 0){
		self_sleep(0);
	}
	zaulog.sem = 1;
	p = zaulog.p;
	e = zaulog.e;
	if(zaulog.lastproc != name || zaulog.nl){
nl:
		if(p < e) *p++ = 13;
		if(p < e) *p++ = 10;
		p = decchi_u10(p,e,sys_gettime(),8);
		if(p < e) *p++ = 32;
		p = decchi_u16(p,e,name,8);
#if 1
		if(p < e) *p++ = 32;
		p = decchi_u16(p,e,(unsigned long)(get_current()),8);
#endif
#if 0
		if(p < e) *p++ = 32;
		p = decchi_u16(p,e,(unsigned long)(&name),8);
#endif
		if(p < e) *p++ = 32;
		if(p < e) *p++ = 32;
		zaulog.nl = 0;
	}
	for(;s < t; ++s){
		if((*s & 0xe0) == 0){
			if(*s == '\n'){
				zaulog.nl = 1;
			}
		}else if(zaulog.nl){
			goto nl;
		}else{
			if(p < e) *p++ = *s;
		}
	}
	zaulog.p = p;
	zaulog.lastproc = name;
	zaulog.sem = 0;
#endif
}

/*======================================================================*/
/*
 * miru
 */
void miru(const char *fmt, ...)
{
#if USE_ZAULOG || USE_ZAUVIEW
	va_list	args;
	int	w, i;
	unsigned char	c, f;
	unsigned char	*e, *s, *t, b[16];
	  /**/
	va_start(args, fmt);
	for(e = b + sizeof(b);;){
		if((c = *fmt++) == 0) goto owari;
		if(c != '%'){
#if USE_ZAUVIEW
			zauview_cdpy_write(&c,1);
#endif
#if USE_ZAULOG
			zaulog_write(&c,1);
#endif
			continue;
		}
		if((c = *fmt++) == 0) goto owari;
		f = ' ';
		w = -1;
		if(c == '0'){
			f = '0';
		}
		if(c >= '0' && c <= '9'){
			w = c - '0';
			for(;;){
				if((c = *fmt++) == 0) goto owari;
				if(c < '0' || c > '9'){
					break;
				}
				w = w * 10 + c - '0';
			}
		}
		if(c == 'l'){
			if((c = *fmt++) == 0) goto owari;
		}
		switch(c){
		case 'c':
			c = (unsigned char)va_arg(args,int);
			/*nobreak*/
		default:
			s = &c;
			t = s + 1;
			goto StringCommon;
		case 's':
			s = va_arg(args, unsigned char*);
			for(t = s; *t != 0; ++t){
				if(t - s >= 2048){
					break;
				}
			}
		StringCommon:
			w -= t - s;
#if USE_ZAUVIEW
			zauview_cdpy_write(s,t-s);
#endif
#if USE_ZAULOG
			zaulog_write(s,t-s);
#endif
			b[0] = ' ';
			while(w > 0){
#if USE_ZAUVIEW
				zauview_cdpy_write(b,1);
#endif
#if USE_ZAULOG
				zaulog_write(b,1);
#endif
				w -= 1;
			}
			break;
		case 'd':
			i = va_arg(args,int);
			t = decchi_s10(b,e,(long)i,w);
			goto NumberCommon;
		case 'x':
			i = va_arg(args,int);
			t = decchi_u16(b,e,(unsigned long)i,w);
			goto NumberCommon;
		case 'p':
			w = 8;
			i = va_arg(args,int);
			t = decchi_u16(b,e,(unsigned long)i,w);
		NumberCommon:
#if USE_ZAUVIEW
			zauview_cdpy_write(b,t-b);
#endif
#if USE_ZAULOG
			zaulog_write(b,t-b);
#endif
			break;
		}
	}
owari:
	va_end(args);
#endif
}

/*----------------------------------------------------------------------*/

void
nanka_misete(char *str)
{
	miru("%s\n",str);
}


void nanka_misete_hex(char *s, u4 v)
{
	miru("%s %lx\n",s,v);
}


void nanka_misete_hex3(char *s, u4 v1, u4 v2, u4 v3)
{
	miru("%s %lx %lx %lx\n",s,v1,v2,v3);
}


void nanka_misete_hex7(char *s, u4 v1, u4 v2, u4 v3, u4 v4, u4 v5, u4 v6, u4 v7)
{
	miru("%s %lx %lx %lx %lx %lx %lx %lx\n",s,v1,v2,v3,v4,v5,v6,v7);
}

/*======================================================================*/
/*
 * startsysproc
 */

OBJECT_NAME startsysproc(char *name, OBJECT_NAME code, OBJECT_NAME proc)
{
	PROC_INI	pak;
	extern OBJECT_NAME code_create_file(OBJECT_NAME, UCHAR*);
	  /**/
	miru("--> startsysproc(%s,%lx,%lx)\n",name,code,proc);
	if(!name){
		goto yame;
	}
	/*
	 * code
	 */
	if(code == 0){
		code = name_generate();
		miru("    code=%lx\n",code);
	}
	code = code_create_file(code,(UCHAR*)name);
	miru("    --> code=%lx\n",code);
	if(code == -1){
		goto yame;
	}
	/*
	 * proc
	 */
	pak.type	= SYSTEM_THREAD;
	pak.priority	= 100; //priority;
	pak.stack_size	= 0x8000; //stack_size;
	pak.code	= code;
	pak.message	= 0;
	if(proc == 0){
		proc = name_generate();
		miru("    proc=%lx\n",proc);
	}
	proc = proc_create(proc,&pak);
	miru("    --> proc=%lx\n",proc);
	if(proc == -1){
		code_delete(code);
		goto yame;
	}
	/*
	 * start
	 */
	if(proc_start(proc) == -1){
		proc_delete(proc);
		code_delete(code);
		goto yame;
	}
	miru("<-- startsysproc\n");
	return proc;
yame:
	miru("<-- startsysproc fail\n");
	return -1;
}

/*======================================================================*/
/*
 * zaukey
 */

#if 0

#define KEYQ_QUEUE	(str_to_name("KEYQ"))
int zaukey_getchar()
{
	QUEUE_PBOX	pbox;
	int		r;
	static int	i = 0, n = 0;
	static char	buf[256];
	  /**/
	while(n <= i){
		pbox.data = buf;
		pbox.timeout = -1;	/* block */
		pbox.size = sizeof(buf);
		if((r = queue_read(KEYQ_QUEUE, &pbox)) == -2){
			return -2;	/* timeout */
		}else if(r == -1){
			return -1;	/* cannot read kybd_read_que */
		}
		i = 0;
		n = pbox.size;
	}
	return *((unsigned char*)buf + i++);
}

#else

//#define ZLBOOT_SEND_QUEUE	(str_to_name("zxls"))
#define ZLBOOT_SEND_QUEUE	0x7a786c73 //(str_to_name("zxls"))
#define ZLBOOT_SEND_BUFFER_LEN	(128)


int zaukey_getchar()
{
	QUEUE_PBOX	pbox;
	int		r;
	static int	i = 0, n = 0;
	static char	buf[256];
	  /**/
again:
	while(n <= i){
		pbox.data = buf;
		pbox.timeout = -1;	/* block */
		pbox.size = sizeof(buf);
		if((r = queue_read(ZLBOOT_SEND_QUEUE, &pbox)) == -2){
			self_sleep(64*3);
			continue;
			//return -2;	/* timeout */
		}else if(r == -1){
			self_sleep(64*60);
			continue;
			//return -1;	/* cannot read kybd_read_que */
		}
		r = *(unsigned char*)buf;
		switch(r){
		case 1: /* key string */
			i = 1;
			n = pbox.size;
#if 0
{ static char sbuf[256];
sprintf(sbuf,__FUNCTION__" r=%x(%d) string len=%x(%d)\n",r,r,n,n);
zaucomm_putstr(sbuf); }
#endif
			break;
		case 2: /* zaurus apm message */
#if 0
{ static char sbuf[256];
sprintf(sbuf,__FUNCTION__" r=%x(%d) command=%x(%d)\n",r,r,buf[1],buf[1]);
zaucomm_putstr(sbuf); }
#endif
			switch(buf[1]){
			case 1: /* stop */
#if 0
//miru(__FUNCTION__" shutdown\n");
				//panic("###############");
				sys_sync();
//miru(__FUNCTION__" shutdown-2\n");
				//ctrl_alt_del();
				//ctrl_alt_del2();
				//sys_reboot(0xfee1dead,672274793,0xCDEF0123);
				//	LINUX_REBOOT_CMD_HALT
				more_stop();
//				free_bootmem_all();
//miru(__FUNCTION__" shutdown-3\n");
				disp_procinfo();
//miru(__FUNCTION__" shutdown-4\n");
				self_end();
#else
				/* 
				 * This routine is far from perfect.
				 */
				
//				kill_all_processes();
				sys_sync();
				umount_all_dev();
				notify_halt();
				more_stop();
				zaucomm_end();
				self_end();
#endif				
				break;
			case 2: /* cont */
				break;
			case 3: /* break */
				return 3;
				break;
			case 4:
				zaucomm_end();
				//zaucomm_init();
				break;
			}
			break;
		case 3: /* other message */
			buf[0] = 15;
			zaucomm_write_wait(buf,pbox.size);
			//zaucomm_write_wait(buf+1,pbox.size-1);
			break;
		}
	}
	r = *((unsigned char*)buf + i++);
miru(__FUNCTION__" r=%x(%d)\n",r,r);
	return r;
	//return *((unsigned char*)buf + i++);
}

#endif


/*======================================================================*/
/*
 * zaucomm
 */


#include <bcommlib.h>


#if 0
	GetBCommErrorؿǼ륨顼ɤˤĤƼޤ
	顼ͤϰʲͤȤ߹碌ˤʤޤ
BCOM_SUCCES	0	顼̵
BCOM_RXOVER	0x0001	塼Сե򵯤FULLˤʤä
BCOM_OVERRUN	0x0002	С󥨥顼򸡽Ф
BCOM_RXPARITY	0x0004	ѥƥ顼򸡽Ф
BCOM_FRAME	0x0008	FRAMING ERROR򸡽Ф
BCOM_BREAK	0x0010	֥졼򸡽Ф
BCOM_CTSTO	0x0020	CTSॢ
BCOM_DSRTO	0x0040	DSRॢ
BCOM_DCDTO	0x0080	DCD(CD,RLSD)ॢ
BCOM_MODE	0x8000	ݡȤǤʤ⡼ɤꤵ줿
#endif


#if 0
	ܡȥޥ
	̾餫ΥܡװȯȡCOMMӥϽǤޤ륢ܡװȯƤǤʤ褦ˤ٤˥ܡȥޥꤷơǤ̵뤹褦ˤޤʲ˥ܡװ򼨤ޤΥܡװȤ߹碌ơܡȥޥꤷޤ
ABORT_OFF		0x00000004	ڤץ줿
ABORT_AUTO_POWER_OFF	0x00000008	ȥѥ
ABORT_BATT_COVER_OPEN	0x00000020	ӳ
ABORT_FATAL_LOW_BAT	0x00000040	ӻ̤ʤ
ABORT_BREAK		0x00000080	ǡץ줿
ABORT_PCCARD0_EJECTBTN	0x00010000	EJECTܥ󤬲줿
ABORT_PCCARD0_REMOVED	0x00020000	ɤȴ
ABORT_PCCARD0_SHUTDOWN	0x00040000	٤ΰŸȤ
ABORT_PCCARD0_WPCHANGED	0x00080000	饤ȥץƥȤ줿
ABORT_ALL		0xFFFFFFFF	ܡװ
ABORT_MAINUNIT_ALL	0x000000FF	Τܡװ
ABORT_PCCARD0_ALL	0x000F0000	PCSockect#0ܡװ
#endif


#define RECV_QUE_SIZE	(4096)
#define SEND_QUE_SIZE	(2048)

static BCOM		*pBCom = NULL;
static COMMDEV		*pDev = NULL;


int zaucomm_init(void)
{
	BCOMMODE mode;
	  /**/
	pBCom = NULL;
	if((pDev = LockCommDev(BLTIN_15PIN_DEV)) == NULL){
		return -1;
	}
	if((pBCom = OpenBComm(pDev, RECV_QUE_SIZE, SEND_QUE_SIZE)) == NULL){
		UnlockCommDev(pDev);
		return -1;
	}
	GetModeBComm(pBCom, &mode);
	mode.ByteSize = DATABIT_8;
	mode.Parity = PARITY_NONE;
	mode.StopBits = STOPBIT_1;
	mode.BaudRate = 38400;
	mode.fTxCtsLook = 1;
	mode.fTxDsrLook = 0;
	mode.fRxDtrDrive = 0;
	mode.fRxRtsDrive = 1;
	mode.fRxXSend = 0;
	mode.fTxXLook = 0;
	SetModeBComm(pBCom, &mode);
/* opening message */
{ char s[] = "\n" __FILE__ ":" __FUNCTION__ " comm 8bit parity-none 1stop 38400 dayo\n", *p, *q; for(p = s, q = s + sizeof(s); p < q; ++p) zaucomm_putchar(*p);}
	return 0;
}


void zaucomm_end(void)
{
	if(pBCom){
		CloseBComm(pBCom);
	}
	pBCom = NULL;
	if(pDev){
		UnlockCommDev(pDev);
	}
}


static void zaucomm_status(BCOMSTAT *s)
{
	miru("UINT:         Status %08x\n",s->Status);
	miru("int:             Sig %x\n",s->Sig);
	miru("ABORTFLAG: AbortCond %08x\n",s->AbortCond);
	miru("UINT: i       cRxQue %d\n",s->cRxQue);
	miru("UINT:         cTxQue %d\n",s->cTxQue);
	miru("UINT: cRxQueCapacity %d\n",s->cRxQueCapacity);
	miru("UINT: cTxQueCapacity %d\n",s->cTxQueCapacity);
	miru("UINT:         Rsv[3]\n");
	self_sleep(64*60);
}


/* ͤϽ񤱤ʤäʸޤϥ顼 */
int zaucomm_putchar(char c)
{
	int	r;
	  /**/
	if(pBCom == NULL){
		return ~0;
	}
	r = WriteBComm(pBCom, (UCHAR*)&c, 1);
	if(r < 0){
		miru("zaucomm_putchar: WriteBComm: ret=%d\n",r);
		r = GetBCommError(pBCom);
		miru("zaucomm_putchar: WriteBComm: error=%x\n",r);
		return ~r;
	}
	return 0;
}


/* ͤϽ񤱤ʤäʸޤϥ顼 */
int zaucomm_write(char *buf, int len)
{
	int	r;
	  /**/
	if(pBCom == NULL){
		return ~0;
	}
	r = WriteBComm(pBCom, (UCHAR*)buf, len);
	if(r < 0){
		miru("zaucomm_write: WriteBComm: ret=%d\n",r);
		r = GetBCommError(pBCom);
		miru("zaucomm_write: WriteBComm: error=%x\n",r);
		return ~r;
	}
	return len-r;
}


/* 塼˶ޤԤ */
/* ͤϥ顼 */
int zaucomm_vacant_txque(int timeout)
{
	int	r;
	BCOMSTAT	State;
	  /**/
	if(pBCom == NULL){
		return ~0;
	}
	if(timeout < 0){
		timeout = BCOM_WAIT_FOREVER;
	}
	r = WaitChangeBCommState(pBCom, &State, BCOM_EVENT_VACANT_TXQUE, timeout);
	if(r != SUCCESS){
		miru("zaucomm_vacant_txque: WaitChangeBCommState: ret=%x\n",r);
		zaucomm_status(&State);
		r = GetBCommError(pBCom);
		miru("zaucomm_vacant_txque: WaitChangeBCommState: error=%x\n",r);
		return ~r;
	}
	return 0;
}


/* ƥ塼˽񤭽ޤԤ */
/* ͤϥ顼 */
int zaucomm_write_wait(char *buf, int len)
{
	int	r;
	  /**/
	for(r = len; r != 0;){
		r = zaucomm_write(buf, r);
		if(r < 0){
			return r;
		}
		r = zaucomm_vacant_txque(-1);
		if(r < 0){
			return r;
		}
	}
	return 0;
}


int zaucomm_putstr(char *s)
{
	char	*p;
	  /**/
	for(p = s; *p != 0; ++p);
	return zaucomm_write_wait(s, p-s);
}


int zaucomm_getchar()
{
	int		r;
	BCOMSTAT	State;
	static int	i = 0, n = 0;
	static char	buf[256];
	  /**/
	while(n <= i){
		r = WaitChangeBCommState(pBCom, &State, BCOM_EVENT_DATA_ARRIVE, BCOM_WAIT_FOREVER);
		if(r != SUCCESS){
			miru("zaucomm_in_proc: WaitChangeBCommState: ret=%x\n",r);
			zaucomm_status(&State);
			r = GetBCommError(pBCom);
			miru("zaucomm_in_proc: WaitChangeBCommState: error=%x\n",r);
			return ~r;
		}
		r = ReadBComm(pBCom, (UCHAR*)buf, sizeof(buf)-1);
		if(r < 0){
			miru("zaucomm_in_proc: ReadBComm: ret=%d\n",r);
			r = GetBCommError(pBCom);
			miru("zaucomm_in_proc: ReadBComm: error=%x\n",r);
			return ~r;
		}
		n = r;
		i = 0;
	}
	return *((unsigned char*)buf + i++);
}


/* ʸɤ߹ */
/* ʻˤerrorȤ-1 */
/* ʳȤˤʸnullǽü */
/* ͤϺǸɤʸ */
int zaucomm_gets(char *b, char *e)
{
	int	c, f;
	char	*p;
	  /**/
	if((p = b) >= --e){
		return -1;	// error
	}
	for(f = 0;;){
		c = zaucomm_getchar();
		if(f != 0){
			--f;
			continue;
		}
		switch(c){
		case 127:
		case 8:
			if(p > b){
				if(*--p < 32){
					zaucomm_putchar(8);
					zaucomm_putchar(32);
					zaucomm_putchar(8);
				}
				zaucomm_putchar(8);
				zaucomm_putchar(32);
				zaucomm_putchar(8);
			}
			break;
		case 13:
		case 10:
			*p = 0;
			zaucomm_putchar(13);
			zaucomm_putchar(10);
			return 10;	// succes
		default:
			if(c < 32){
				if(p < e){
					*p++ = c;
					zaucomm_putchar('^');
					zaucomm_putchar(c | 64);
				}
			}else if(c < 128){
				if(p < e){
					*p++ = c;
					zaucomm_putchar(c);
				}
			}else{
				f = 1;	// ʸɤФ
			}
		}
	}
}

/*======================================================================*/
/*
 *
 */

extern u1 fontdata_6x11[];
extern u1 fontdata_8x8[];
extern u1 fontdata_8x16[];

static ZXSCRN	*scrn;
static ZXSCRN	scrn_ex1 = { 0, 0, 1024, 480, 640, 480 };
static ZXSCRN	scrn_c1  = { 0, 0,  320, 240, 320, 240 };

static ZXWIND	wind_ex1_full = { 0,   0, 640, 480 }; // 80x25(8x16)  80x24(8x20)
static ZXWIND	wind_ex1_cons = { 0,   0, 640, 304 }; // 80x19(8x16)  80x38(8x8)
static ZXWIND	wind_ex1_con1 = { 0,   0, 640, 300 }; // 80x25(8x12)
static ZXWIND	wind_ex1_con2 = { 0,   0, 640, 288 }; // 80x18(8x16)  80x24(8x12)  8x36(8x8)
static ZXWIND	wind_ex1_inpt = { 5, 308, 630, 168 }; // 90x14(7x12) 105x15(6x11)

static ZXWIND	wind_c1_full = { 0,   0, 320, 240 }; // 40x24(8x10)
static ZXWIND	wind_c1_cons = { 0,   0, 320, 152 }; // 40x19(8x8)
static ZXWIND	wind_c1_con1 = { 0,   0, 320, 150 }; // 40x15(8x10)
static ZXWIND	wind_c1_con2 = { 0,   0, 320, 144 }; // 40x9(8x16) 40x18(8x8)
static ZXWIND	wind_c1_inpt = { 2, 155, 315,  84 }; // 45x7(7x12) 52x7(6x11)

static ZXFONT	font_6x11 = { fontdata_6x11, 6, 11, 11 };
static ZXFONT	font_8x8  = { fontdata_8x8,  8,  8,  8 };
static ZXFONT	font_8x16 = { fontdata_8x16, 8, 16, 16 };


#ifdef OLD_OLD
static ZXWIND	full_screen = { 0,   0, 0, 0, 0, 0, 80, 24, 16, 40 };
static ZXWIND	upper_area =  { 0,   0, 0, 8, 0, 8, 80, 15, 16, 40 };
static ZXWIND	input_area =  { 8, 620, 0, 8, 0, 8, 79,  8, 16, 40 };
	/*            x0  y0 col lin  cw, ch  */
	zauview_init( 20,306,100, 14,  6, 12, linux_6x11, 6, 11);
	zaucons_init(  0,  0, 80, 24,  8, 12, linux_8x8, 8, 8);
	zaucons_init(  0,  0, 80, 19,  8, 16, linux_8x16, 8, 16);
#endif


void zaurus_init()
{
	UCHAR	ModelName[MODEL_NAME_MAX];
	ULONG	Version;
	UPOINT	ScreenSize;
	DPI	DPISize;
	BOOLEAN	vgap;
	ZXSCRN	*s;
	  /**/
#if 0
	GetSystemInfo(ModelName,&Version);
	if((Version>>16) < MODEL_NUMBER_MIEX1){
		/* MI-EX1εϼ¹ԤǤʤ */
		return -1;
		/* self_end(); */
	}else{
		/* MI-EX1ʤޤ˰ʹߤεξ */
		GetScreenSizeAndDPI(&ScreenSize, &DPISize);
	}
#else
	GetScreenSizeAndDPI(&ScreenSize, &DPISize);
#endif
	if((ScreenSize.x < 640) || (ScreenSize.y < 480)){
		s = &scrn_c1;
		zxscrn_init(s);
		//zxscrn_init_vram(s);
		zauview_init(s,&wind_c1_inpt,&font_6x11,7,12);
		zaucons_init(s,&wind_c1_cons,&font_8x8,8,8);
	}else{
		s = &scrn_ex1;
		zxscrn_init(s);
		//zxscrn_init_vram(s);
		zauview_init(s,&wind_ex1_inpt,&font_6x11,7,12);
		zaucons_init(s,&wind_ex1_cons,&font_8x16,8,16);
	}
	scrn = s;
	zaulog_init();
miru("WnHandle=%x\n",scrn->wh);
miru("vramtop=%p\n",scrn->screen_top);
}

/* EOF */
/*======================================================================*/
/*
 * dbg
 */

unsigned long dump_target;
unsigned long dump_address;
unsigned long dump_length;


void memdump()
{
	unsigned long	a;
	int	c, i, j;
	char	*p, *q, b[79], f[79];
	  /**/
/*        1         2         3         4         5         6         7
0123456789012345678901234567890123456789012345678901234567890123456789012345678
01234567: 00 11 22 33 44 55 66 77  88 99 aa bb cc dd ee ff |0123456789abcdef|+
*/
	for(q = f; q < f + sizeof(f);){
		*q++ = ' ';
	}
	f[8] = ':';
	f[59] = f[76] = '|';
	f[77] = '\n';
	f[78] = 0;
	a = dump_address;
	for(i = 0, j = dump_length; --j >= 0;){
		if(i == 0){
			for(p = b, q = f; q < f + sizeof(f);){
				*p++ = *q++;
			}
			put_n16r(b,a,8);
			p = b + 10;
		}
		if(dump_target == 0){
			c = *(unsigned char*)a;
		}else{
			c = dbg_mem_get1(dump_target,a);
		}
		++a;
		if(c == -1){
			p[0] = p[1] = '-';
			b[60+i] = '-';
		}else{
			put_n16r(p,c,2);
			if(c < ' ' || c >= 127){
				c = '.';
			}
			b[60+i] = c;
		}
		p += 3;
		if(++i == 8){
			++p;
		}
		if(i == 16){
			zaucomm_putstr(b);
			i = 0;
		}
	}
	if(i != 0){
		zaucomm_putstr(b);
	}
	dump_address = a;
}


void viewret(int i)
{
	char	*p, b[40];
	for(p = b; p < b + sizeof(b);){
		*p++ = ' ';
	}
	put_n16r(b,i,8);
	put_n10l(b+10,i,10);
	b[20] = '\n';
	b[21] = 0;
	zaucomm_putstr(b);
}


unsigned long d_strname(char *s)
{
	unsigned long	n;
	int	c;
	char	*p;
	  /**/
	if(*s == '0' && s[1] == 'x'){
		n = simple_strtoul(s,0,0);
		return n;
	}
	if(*s == '#'){
		n = 0;
		p = s + 1;
		while((c = *(unsigned char*)p++) != 0){
			if(c < '0' || c > '9'){
				goto NAME4;
			}
			n = n * 10 + c - '0';
		}
		n |= 0x80000000;
		return n;
	}
NAME4:
	n = 0;
	for(p = s; (c = *(unsigned char*)p) != 0 && p - s < 4; ++p){
		n = n << 8 | c;
	}
	return n;
}

void do_cmd(int ac, char **av)
{
	int	i, j, k;
	char	b[80];
	  /**/
	if(ac < 1 || av[0][0] == '#'){
		return;
	}
	if(strcmp(av[0],"ps") == 0){
		disp_procinfo();
	}else if(strcmp(av[0],"memlist") == 0){
		disp_memlist();
	}else if(strcmp(av[0],"namelist") == 0){
		i = 0;
		if(ac >= 2){
			i = simple_strtol(av[1],0,0);
		}
		disp_namelist(i);
	}else if(strcmp(av[0],"obj") == 0){
		for(i = 1; i < ac; ++i){
			disp_objinfo(d_strname(av[i]));
		}
	}else if(strcmp(av[0],"target") == 0){
		if(ac != 2){
miru("usage: target <name>\n");
			disp_objinfo(dump_target);
		}else{
			dump_target = d_strname(av[1]);
			disp_objinfo(dump_target);
		}
	}else if(strcmp(av[0],"dump") == 0){
		if(ac >= 2){
			dump_address = simple_strtoul(av[1],0,0);
		}
		if(ac >= 3){
			dump_length  = simple_strtoul(av[2],0,0);
		}
		if(dump_length > 512){
			dump_length = 512;
		}
		memdump();
	}else if(strcmp(av[0],"memarea") == 0){
		int a[4];
		if(ac == 1){
			i = dump_target;
			viewret(i);
			i = proc_memarea(i,a);
			viewret(i);
			viewret(a[0]);
			viewret(a[1]);
			viewret(a[2]);
			viewret(a[3]);
		}else{
			for(i = 1; i < ac; ++i){
				i = d_strname(av[1]);
				viewret(i);
				i = proc_memarea(i,a);
				viewret(i);
				viewret(a[0]);
				viewret(a[1]);
				viewret(a[2]);
				viewret(a[3]);
			}
		}
	}else if(strcmp(av[0],"proc_delete") == 0){
		if(ac == 1){
			i = dump_target;
			viewret(i);
			i = proc_delete(i);
			viewret(i);
		}else{
			for(i = 1; i < ac; ++i){
				i = d_strname(av[i]);
				viewret(i);
				i = proc_start(i);
				viewret(i);
			}
		}
	}else if(strcmp(av[0],"proc_start") == 0){
		if(ac == 1){
			i = dump_target;
			viewret(i);
			i = proc_start(i);
			viewret(i);
		}else{
			for(i = 1; i < ac; ++i){
				i = d_strname(av[1]);
				viewret(i);
				i = proc_start(i);
				viewret(i);
			}
		}
	}else if(strcmp(av[0],"proc_stop") == 0){
		if(ac == 1){
			i = dump_target;
			viewret(i);
			i = proc_stop(i);
			viewret(i);
		}else{
			for(i = 1; i < ac; ++i){
				i = d_strname(av[1]);
				viewret(i);
				i = proc_stop(i);
				viewret(i);
			}
		}
	}else if(strcmp(av[0],"proc_wakeup") == 0){
		if(ac == 1){
			i = dump_target;
			viewret(i);
			i = proc_wakeup(i);
			viewret(i);
		}else{
			for(i = 1; i < ac; ++i){
				i = d_strname(av[1]);
				viewret(i);
				i = proc_wakeup(i);
				viewret(i);
			}
		}
	}else if(strcmp(av[0],"proc_sleep") == 0){
		if(ac == 1){
			i = dump_target;
			viewret(i);
			i = proc_sleep(i,-1);
			viewret(i);
		}else if(ac == 2){
			i = d_strname(av[1]);
			viewret(i);
			i = proc_sleep(i,-1);
			viewret(i);
		}else if(ac == 3){
			i = d_strname(av[1]);
			viewret(i);
			j = simple_strtol(av[1],0,0);
			i = proc_sleep(i,j);
			viewret(i);
		}
	}else if(strcmp(av[0],"dbg_reg_get") == 0){
		if(ac == 1){
			k = dump_target;
			for(i = 0; i < 22; ++i){
				j = dbg_reg_get(k,i);
				viewret(j);
			}
		}else if(ac == 2){
			k = d_strname(av[1]);
			for(i = 0; i < 22; ++i){
				j = dbg_reg_get(k,i);
				viewret(j);
			}
		}else{
			k = d_strname(av[1]);
			for(i = 3; i < ac; ++i){
				j = simple_strtol(av[i],0,0);
				j = dbg_reg_get(k,j);
				viewret(j);
			}
		}
	}else if(strcmp(av[0],"dbg_reg_put") == 0){
		if(ac == 3){
			i = dump_target;
			j = simple_strtoul(av[1],0,0);
			k = simple_strtoul(av[2],0,0);
			i = dbg_reg_put(i,j,k);
			viewret(i);
		}else if(ac == 4){
			i = d_strname(av[1]);
			j = simple_strtoul(av[2],0,0);
			k = simple_strtoul(av[3],0,0);
			i = dbg_reg_put(i,j,k);
			viewret(i);
		}
	}else if(strcmp(av[0],"dbg_mem_get1") == 0){
		if(ac == 3){
			i = d_strname(av[1]);
			j = simple_strtoul(av[2],0,0);
			i = dbg_mem_get1(i,j);
			viewret(i);
		}
	}else if(strcmp(av[0],"dbg_mem_put1") == 0){
		if(ac == 4){
			i = d_strname(av[1]);
			j = simple_strtoul(av[2],0,0);
			k = simple_strtoul(av[3],0,0);
			i = dbg_mem_put1(i,j,k);
			viewret(i);
		}
	}else if(strcmp(av[0],"dbg_mem_get4") == 0){
		if(ac == 3){
			i = d_strname(av[1]);
			j = simple_strtoul(av[2],0,0);
			i = dbg_mem_get4(i,j);
			viewret(i);
		}
	}else if(strcmp(av[0],"dbg_mem_put4") == 0){
		if(ac == 4){
			i = d_strname(av[1]);
			j = simple_strtoul(av[2],0,0);
			k = simple_strtoul(av[3],0,0);
			i = dbg_mem_put4(i,j,k);
			viewret(i);
		}
	}else if(strcmp(av[0],"dbg_proc_stop") == 0){
		if(ac == 2){
			i = d_strname(av[1]);
			i = dbg_proc_stop(i);
			viewret(i);
		}
	}else if(strcmp(av[0],"dbg_proc_resume") == 0){
		if(ac == 2){
			i = d_strname(av[1]);
			i = dbg_proc_resume(i);
			viewret(i);
		}
	}else if(strcmp(av[0],"proc_log2phy_address") == 0){
		if(ac == 2){
			i = dump_target;
			j = simple_strtoul(av[1],0,0);
			i = proc_log2phy_address(i,j);
			viewret(i);
		}else if(ac >= 3){
			i = d_strname(av[1]);
			j = simple_strtoul(av[2],0,0);
			i = proc_log2phy_address(i,j);
			viewret(i);
		}
	}else if(strcmp(av[0],"dbg_break_point_set") == 0){
		if(ac == 2){
			i = dump_target;
			j = simple_strtoul(av[1],0,0);
			i = dbg_break_point_set(i,j);
			viewret(i);
		}else if(ac == 3){
			i = d_strname(av[1]);
			j = simple_strtoul(av[2],0,0);
			i = dbg_break_point_set(i,j);
			viewret(i);
		}
	}else if(strcmp(av[0],"dbg_break_point_clear") == 0){
		if(ac == 2){
			i = dump_target;
			j = simple_strtoul(av[1],0,0);
			i = dbg_break_point_clear(i,j);
			viewret(i);
		}else if(ac == 3){
			i = d_strname(av[1]);
			j = simple_strtoul(av[2],0,0);
			i = dbg_break_point_clear(i,j);
			viewret(i);
		}
#if 0
	}else if(strcmp(av[0],"ProcMemExpand") == 0){
		i = dump_target;
		j = 0;
		if(ac >= 2){
			i = d_strname(av[1]);
		}
		if(ac >= 3){
			j = simple_strtol(av[2],0,0);
		}
		i = ProcMemExpand(i,j);
		viewret(i);
#endif
	}else if(strcmp(av[0],"u4") == 0){
		for(i = 1; i < ac; ++i){
			j = *(unsigned long*)simple_strtol(av[i],0,0);
			viewret(j);
		}
	}else if(strcmp(av[0],"u2") == 0){
		for(i = 1; i < ac; ++i){
			j = *(unsigned short*)simple_strtol(av[i],0,0);
			viewret(j);
		}
	}else if(strcmp(av[0],"u1") == 0){
		for(i = 1; i < ac; ++i){
			j = *(unsigned char*)simple_strtol(av[i],0,0);
			viewret(j);
		}
	}
}

/*======================================================================*/
/*
 * zxfb
 */

struct user_area {
	u4	proc;
	u4	log_next_page;
	u4	log_stop;
	u4	phy;
	u4	phy_next_page;
};

static void user_proc(struct user_area *u, u4 proc, u4 addr, u4 stop)
{
	u->proc = proc;
	u->log_next_page = addr;
	if(stop == 0){
		u->log_stop = stop;
	}
	u->phy = u->phy_next_page = 0;
}

static int user_address(struct user_area *u, u4 addr)
{
	u4	phy;
	  /**/
	phy = proc_log2phy_address(u->proc,addr);
	if(phy == ~0){
		return -2;
	}
	u->log_next_page = (addr | 0x3ff) + 1;
	u->phy = phy;
	u->phy_next_page = (phy | 0x3ff) + 1;
	return 0;
}

static int user_getul(struct user_area *u, unsigned long *ul)
{
	int	i;
	u4	addr;
	  /**/
	if(u->phy == u->phy_next_page){
		i = user_address(u,u->log_next_page);
		if(i < 0){
			return i;
		}
	}
	*ul = *(unsigned long*)(addr = u->phy & ~3);
	u->phy = addr + 4;
	return 0;
}

static int user_getl(struct user_area *u, long *l)
{
	int	i;
	unsigned long	addr;
	  /**/
	if(u->phy == u->phy_next_page){
		i = user_address(u,u->log_next_page);
		if(i < 0){
			return i;
		}
	}
	*l = *(long*)(addr = u->phy & ~3);
	u->phy = addr + 4;
	return 0;
}

/*----------------------------------------------------------------------*/

static void user_miru(struct user_area *u)
{
	miru("u=%p proc=%x lognext=%x logstop=%x phy=%x phynext=%x\n",u,u->proc,u->log_next_page,u->log_stop,u->phy,u->phy_next_page);
}

int zxfb_put(struct user_area *u0, u4 cmd)
{
	long	x, y;
	u4	w, h;
	int	i, j;
	u4	c;
	u2	*s, *p;
	//ACSVRAM	acsVram;
	unsigned char	acsVram;
	  /**/
	if(user_getl(u0,&x) == -1) goto yame;
	if(user_getl(u0,&y) == -1) goto yame;
	if(user_getul(u0,&w) == -1) goto yame;
	if(user_getul(u0,&h) == -1) goto yame;
//miru(" %4d %4d %4d %4d\n",x,y,w,h);
	s = scrn->screen_top + 1024 * y;
	acsVram = EnableAccessVRAM();
	for(j = y; j < y + h; ++j){
		p = s + x;
		for(i = x; i < x + w; ++i){
			if(user_getul(u0,&c) == -1){
				c = ~0;
			}
			if(i < 0 || x >= scrn->screen_clip_w || y < 0 || y >= scrn->screen_clip_h){
				continue;
			}
			*p++ = c;
		}
		s += scrn->screen_w;
	}
	DisableAccessVRAM(acsVram);
	return 0;
yame:
	return -1;
}


int zxfb_put2(struct user_area *u0, u4 cmd)
{
	long	x, y;
	u4	w, h;
	int	i, j;
	u4	c;
	u2	*s, *p;
	//ACSVRAM	acsVram;
	unsigned char	acsVram;
	  /**/
	if(user_getl(u0,&x) == -1) goto yame;
	if(user_getl(u0,&y) == -1) goto yame;
	if(user_getul(u0,&w) == -1) goto yame;
	if(user_getul(u0,&h) == -1) goto yame;
//miru(" %4d %4d %4d %4d\n",x,y,w,h);
	s = scrn->screen_top + 1024 * y;
	acsVram = EnableAccessVRAM();
	for(j = y; j < y + h; ++j){
		p = s + x;
		for(i = x; i < x + w; ++i){
			if(user_getul(u0,&c) == -1){
				c = ~0;
			}
			if(i < 0 || x >= scrn->screen_clip_w || y < 0 || y >= scrn->screen_clip_h){
				continue;
			}
			p[0] = c;
			p[1] = c;
			p[scrn->screen_w] = c;
			p[scrn->screen_w+1] = c;
			p += 2;
		}
		s += scrn->screen_w * 2;
	}
	DisableAccessVRAM(acsVram);
	return 0;
yame:
	return -1;
}


void zxfb_serv(void)
{
	QUEUE_PBOX		fbbox;
	OBJECT_NAME		fbq;
	unsigned long		cmd;
	unsigned long		buf[2]; /* addr, size */
	struct user_area	u0[1];
	  /**/
//miru(__FUNCTION__"\n");
	self_setpriority(2400);
	fbq = 0x5a784662/*'ZxFb'*/;
	for(;;){
		fbbox.data = (UBYTE*)&buf;
		fbbox.size = sizeof(buf);
		fbbox.timeout = -1;
		while(queue_read(fbq,&fbbox) == -1){
//miru(__FUNCTION__": queue_read error\n");
			queue_create(fbq, 8, sizeof(buf));
			self_sleep(960); /* 15sec*/
		}
		if(fbbox.size != sizeof(buf) || buf[1] == 0){
			continue;
		}
//miru(__FUNCTION__" proc=%p addr=%x size=%d\n",fbbox.sender,buf[0],buf[1]);
		user_proc(u0,fbbox.sender,buf[0],buf[0]+buf[1]);
//user_miru(u0);
		if(user_getl(u0,&cmd) < 0){
			continue;
		}
		switch(cmd){
		case 1: zxfb_put(u0,cmd); break;
		case 2: zxfb_put2(u0,cmd); break;
		case 0x71756974/*'quit'*/:
			self_end();
		default:
			break;
		}
//		self_sleep(1);
	}
}


#if 1
void bcopy(const void *src, void *dst, int n)
{
	const char	*s;
	char		*d;
	  /**/
	for(d = (char*)dst, s = (char*)src; n != 0; --n){
		*d++ = *s++;
	}
}


int strcmp(const char *str1, const char *str2)
{
	int c;
	  /**/
	for(;;){
		if((c = *str1 - *str2) != 0){
			return c;
		}
		if(*str1 == 0){
			return 0;
		}
		++str1, ++str2;
	}
}
#endif
