#ifndef __ASM_SH_TIMER_H
#define __ASM_SH_TIMER_H

#define ZX_SYSCALL_STAT_INVAL   (-1)  /* queue read failed (force retry reading) */
#define ZX_SYSCALL_STAT_NORMAL	0     /* return value is ok */
#define ZX_SYSCALL_STAT_SIGNAL	1     /* system call is interrupted by signal
				       * (force retry calling)
				       */

struct callpack_t { 
	int sys_no;
	int a1, a2, a3, a4, a5;
};

struct retpack_t{ 
	int status;
	int retval;
};

#ifdef __KERNEL__

extern int syscall_wait(void);
extern int syscall_separate(int syscall_nr, int retval);

#endif

extern inline syscall_queuename_r(unsigned long seed)
{
  return (seed & 0xffff) | 0x4c430000;
}

extern inline syscall_queuename_w(unsigned long seed)
{
  return (seed & 0xffff) | 0x4c520000;
}

#endif /* __ASM_SH_TIMER_H */

